> ## Documentation Index > Fetch the complete documentation index at: https://developers.cmicglobal.com/llms.txt > Use this file to discover all available pages before exploring further. # Retrieve User Extension Field Value By Object > ## Overview User Extensions allow the functionality of the software to be extended through the creation of custom input fields. These input fields are attached to custom tables. The tables allow for storage and easy access of all miscellaneous information. ## Notes - Before working with a User Extension Field value, retrieve its definition using the User Extension Definition endpoint. Once the definition is established in CMiC, you can create, retrieve, or update the field’s value as needed - Finders must be used to properly query GET requests. ## UI Navigation System > User Extension > Field Maintenance ## Reference Article - [Creating a User Extension Field Value](https://developers.cmicglobal.com/v1/docs/creatingupdating-a-user-extension-field-value) - [UE Maintenance Overview](https://docs.cmicglobal.com/portal/Content/E_Reference_Material/SD_-_System_Data/Reference/User_Extensions/UE_Maintenance.htm) ## Path Parameters | Parameter | Description | Example | | --- | --- | --- | | VUUID | The VUuid attribute is the Unique row ID | /sys-rest-api/rest/1/sdobjusrextvalue/E41D15789AA9807FE0530100007F304F | ## Query Standards | Key | Recommended | Description | | --- | --- | --- | | finder | Yes | Filters data based on attributes. See finder details below. Finders can be combined using a comma delimiter between parameters that implies an "and" statement. For more information on using the finder functionality please see \[Best Practice | | limit | Yes | A limit restricts the number of resources returned inside the resource collection. If the limit exceeds the resource count, then the framework will return all available resources. For additional information on using the limit functionality please visit \[Best Practice | | offset | Yes | The offset skips a specified number of items in a data list before it starts showing results. For example, if you set an offset of 10, it skips the first 10 items and begins showing from the 11th item. For additional information on using Offset functionality please visit \[Best Practice | | orderBy | Yes | The orderBy attribute retrieves rows using an order ensuring the response payload displays data in the order supplied in the URL parameter using the GET method. For more information on using orderBy functionality please visit \[Best Practice | ## (User Extension Field Value) Finders | Finder | Parameter | Data Type | Description | Example | | --- | --- | --- | --- | --- | | PrimaryKey | UevVUuid | string | Filter values by VUUID | /sys-rest-api/rest/1/sdobjusrextvalue?finder=PrimaryKey;UevVUuid=E41D15789AA9807FE0530100007F304F | | SdObjUsrExtValueFinder | AuditDate | date | Filter records by audit date (UevIuCreateDate). This finder will retrieve records that have a created date on or after the specified date. When using this finder, this parameter must be used in tandem with the Schema Name, Table Name, and the all associated Object keys. | /sys-rest-api/rest/1/sdobjusrextvalue?finder=SdObjUsrExtValueFinder;AuditDate=2010-10-31, SchemaName=DA, TableName=PYEMPLOYEE_TABLE,ObjectKey1=ZZ-100 | | SdObjUsrExtValueFinder | ObjectKey1 | string | Filter record by Object Key 1. When using this finder, this parameter must be used in tandem with the Schema Name, Table Name, and the all other associated Object keys. | /sys-rest-api/rest/1/sdobjusrextvalue?finder=SdObjUsrExtValueFinder; SchemaName=DA, TableName=BPVENDORS,ObjectKey1=ZZ, ObjectKey2=00112233 | | SdObjUsrExtValueFinder | ObjectKey2 | string | Filter record by Object Key 2. When using this finder, this parameter must be used in tandem with the Schema Name, Table Name, and the all other associated Object keys. | /sys-rest-api/rest/1/sdobjusrextvalue?finder=SdObjUsrExtValueFinder; SchemaName=DA, TableName=BPVENDORS,ObjectKey1=ZZ, ObjectKey2=00112233 | | SdObjUsrExtValueFinder | ObjectKey3 | string | Filter record by Object Key 3. When using this finder, this parameter must be used in tandem with the Schema Name, Table Name, and the all other associated Object keys. | /sys-rest-api/rest/1/sdobjusrextvalue?finder=SdObjUsrExtValueFinder; SchemaName=DA, TableName=SCMAST,ObjectKey1=CCC, ObjectKey2=1TIME, ObjectKey3=CCCJB-0000001, ObjectKey4=000 | | SdObjUsrExtValueFinder | ObjectKey4 | string | Filter record by Object Key 4. When using this finder, this parameter must be used in tandem with the Schema Name, Table Name, and the all other associated Object keys. | /sys-rest-api/rest/1/sdobjusrextvalue?finder=SdObjUsrExtValueFinder; SchemaName=DA, TableName=SCMAST,ObjectKey1=CCC, ObjectKey2=1TIME, ObjectKey3=CCCJB-0000001, ObjectKey4=000 | | SdObjUsrExtValueFinder | SchemaName | string | Filter record by Schema Name. When using this finder, this parameter must be used in tandem with the Table Name, and all associated Object keys | /sys-rest-api/rest/1/sdobjusrextvalue?finder=SdObjUsrExtValueFinder; SchemaName=DA, TableName=BPVENDORS,ObjectKey1=ZZ, ObjectKey2=00112233 | | SdObjUsrExtValueFinder | TableName | string | Filter record by Table Name. When using this finder, this parameter must be used in tandem with the Schema Name, and all associated Object keys | /sys-rest-api/rest/1/sdobjusrextvalue?finder=SdObjUsrExtValueFinder; SchemaName=DA, TableName=BPVENDORS,ObjectKey1=ZZ, ObjectKey2=00112233 | | UevCodeFinder | AuditDate | string | Filter records by audit date (UevIuCreateDate). This finder will retrieve records that have a created date on or after the specified date. | /sys-rest-api/rest/1/sdobjusrextvalue?finder=UevCodeFinder;AuditDate=2025-01-31 | | UevCodeFinder | SchemaName | string | Filter records by Schema Name. | /sys-rest-api/rest/1/sdobjusrextvalue?finder=UevCodeFinder;SchemaName=DA | | UevCodeFinder | TableName | string | Filter Records by Table Name | /sys-rest-api/rest/1/sdobjusrextvalue?finder=UevCodeFinder;TableName=PYEMPLOYEE_TABLE | | UevCodeFinder | UevCode1Var | string | Filter Records by UevCode1. | /sys-rest-api/rest/1/sdobjusrextvalue?finder=UevCodeFinder;UevCode1Var=1 | | UevCodeFinder | UevCode2Var | string | Filter Records by UevCode2. | /sys-rest-api/rest/1/sdobjusrextvalue?finder=UevCodeFinder;UevCode2Var=20122022 | | UevCodeFinder | UevCode3Var | string | Filter Records by UevCode3. | /sys-rest-api/rest/1/sdobjusrextvalue?finder=UevCodeFinder;UevCode3Var=100 | | UevCodeFinder | UevCode\[1-20\]Var | string | Filter records by UEV Code fields (replace \[1-20\] with the desired number). | /sys-rest-api/rest/1/sdobjusrextvalue?finder=UevCodeFinder;UevCode18Var=100100 | | findByDate | AuditDate | string | Filter records by audit date (UevIuCreateDate). This finder will retrieve records that have a created date on or after the specified date. | /sys-rest-api/rest/1/sdobjusrextvalue?finder=findByDate;AuditDate=2025-01-31 | | findByDate | SchemaName | string | Filter records by Schema Name. | /sys-rest-api/rest/1/sdobjusrextvalue?finder=findByDate;SchemaName=DA | | findByDate | TableName | string | Filter Records by Table Name | /sys-rest-api/rest/1/sdobjusrextvalue?finder=findByDate;TableName=PYEMPLOYEE_TABLE | | findByDate | UevCode10Var | string | Filter Records by UevCode1. | /sys-rest-api/rest/1/sdobjusrextvalue?finder=findByDate;UevCode1Var=1 | | findByDate | UevCode2Var | string | Filter Records by UevCode2. | /sys-rest-api/rest/1/sdobjusrextvalue?finder=findByDate;UevCode2Var=20122022 | | findByDate | UevCode3Var | string | Filter Records by UevCode3. | /sys-rest-api/rest/1/sdobjusrextvalue?finder=findByDate;UevCode3Var=100 | | findByDate | UevCode\[1-20\]Var | string | Filter records by UEV Code fields (replace \[1-20\] with the desired number). | /sys-rest-api/rest/1/sdobjusrextvalue?finder=findByDate;UevCode18Var=1234 | ## (User Extension Field Value) Attributes ### General Attributes | CMiC UI Fieldname | Name | Description | Type | Data Length | Example | Required | | --- | --- | --- | --- | --- | --- | --- | | Schema Name | UevUedSchemaName | Static code 'DA' | string | 30 | ‘DA’ | Yes | | Table Name | UevUedTableName | Enter the Object Type Table Name. In CMiC, object tables are database tables that store rows of records.

Click [here](https://developers.cmicglobal.com/v1/docs/object-key-tables) to view a list of Object Tables. | string | 30 | ‘PYEMPLOYEE_TABLE’ | Yes | | VUUID | UevVUuid | The VUuid attribute is the Unique row ID | string | 64 | E41D157899B9807FE0530100007F304F | No | | Create Date | UevIuCreateDate | This field displays the date and time when any user-defined field (UDF) value was first assigned to a record. For example, if you initially set UEV_CODE1 for a record, that timestamp becomes the create date—even if additional UDF values (such as UEV_CODE2, UEV_NUM1, etc.) are added later. | Datetime | | 2018-09-25T11:58:09-04:00 | | | Update Date | UevIuUpdateDate | This field shows the most recent date and time when any UDF value within the record was created or updated. Since all UDF values for a record are stored together, UevIuUpdateDate reflects the timestamp of the latest modification made to any of those fields. | Datetime | | 2025-01-27T17:52:51-05:00 | | | (Deprecated) | UevObjectColumn | This field has been deprecated and should be left blank. | string | 64 | \- | | | (Deprecated) | UevObjectValue | This field has been deprecated and should be left blank. | string | 4000 | \- | | | Object Keys | UevObjectKey | Please refer to the Object Keys Section below for more information | … | … | … | | | UEV Codes | UevCode | Please refer to the UEV Code Section below for more information | … | … | … | | | UEV Numbers | UevNum | Please refer to the UEV Number Section below for more information | … | … | … | | | UEV Dates | UevDate | Please refer to the UEV Date Section below for more information | … | … | … | | ### Object Keys The UEV Keys in the Object Table are unique identifiers used to retrieve specific records. Refer to the [Object Key Tables](https://developers.cmicglobal.com/v1/docs/object-key-tables) for a comprehensive list of Object Types and their corresponding Keys. CMiC UI Fieldname Name Description Type Data Length Example Object Key 1 UevObjectKey1 Unique identifier for record retrieval. For example, when using PYEMPLOYEE_TABLE, Object Key 1 corresponds to Emp Number. In which case you would enter the Employee number (e.g. 1406) string 30 1406 Object Key 2 UevObjectKey2 Unique identifier for record retrieval. For example, when using BPVENDORS, Object Key 2 corresponds to Bp Code. In which case you would enter the BP Code (e.g. ZZ) string 30 ZZ Object Key 3 UevObjectKey3 Unique identifier for record retrieval. For example, when using CMMAST, Object Key 3 corresponds to Cmm Code. In which case you would enter the Cmm Code (e.g. 0009EXT) string 30 0009EXT Object Key 4 UevObjectKey4 Unique identifier for record retrieval. For example, when using SCMAST, Object Key 4 corresponds to Change Code. In which case you would enter the Chagne Code (e.g. 001) string 30 001 ### UEV Codes UEV Code represents a user-defined field (UDF) configured to store string values. All UevCode fields correspond to custom fields for the table specified in the ‘UevUedTableName’ field. Their definitions can be retrieved using the [User Extension Definition](https://developers.cmicglobal.com/apidocs/retrieve-user-extension-fields-definitions-by-code) endpoint. For more details on creating, updating, or reviewing values, see the [Creating a User Extension Field Value](https://developers.cmicglobal.com/v1/docs/creatingupdating-a-user-extension-field-value) guide. | CMiC UI Fieldname | Name | Description | Type | Data Length | Example | | --- | --- | --- | --- | --- | --- | | Uev Code 1 | UevCode1 | User-defined field. Refer to the User Extension Definition endpoint for detail.

For example, UevCode1 associated with the PYEMPLOYEE_TABLE might be defined in the User Extension Definition as the attribute "Driver License." In this case, you would store the driver's license information in that field (e.g. AW-1425-77888). Alternatively, UevCode1 could represent a different user-defined value depending on its configuration.. | string | 4000 | AW-1425-77888 | | Uev Code 2 | UevCode2 | User-defined field. Refer to the User Extension Definition endpoint for details

For example, UevCode2 associated with the PYEMPLOYEE_TABLE might be defined in the User Extension Definition as the attribute "Driver License." In this case, you would store the driver's license information in that field(e.g. AW-1425-77888). Alternatively, UevCode2 could represent a different user-defined value depending on its configuration. | string | 4000 | AW-1425-77888 | | Uev Code 3 | UevCode3 | User-defined field. Refer to the User Extension Definition endpoint for details

For example, UevCode3 associated with the PYEMPLOYEE_TABLE might be defined in the User Extension Definition as the attribute "Driver License." In this case, you would store the driver's license information in that field (e.g. AW-1425-77888). Alternatively, UevCode3 could represent a different user-defined value depending on its configuration. | string | 4000 | AW-1425-77888 | | … | … | ... (Additional UEV Codes follow the same structure) | string | 4000 | … | | UEV Code 100 | UevCode100 | User-defined field. Refer to the User Extension Definition endpoint for details.

For example, UevCode100 associated with the PYEMPLOYEE_TABLE might be defined in the User Extension Definition as the attribute "Driver License." In this case, you would store the driver's license information in that field (e.g. AW-1425-77888). Alternatively, UevCode100 could represent a different user-defined value depending on its configuration. | string | 4000 | AW-1425-77888 | ### UEV Numbers Similar to UEV Codes, UEV Numbers represents a user-defined field (UDF) configured to store numeric values. All UevNum fields correspond to custom fields for the table specified in the ‘UevUedTableName’ field. Their definitions can be retrieved using the [User Extension Definition](https://developers.cmicglobal.com/apidocs/retrieve-user-extension-fields-definitions-by-code) endpoint. For more details on creating, updating, or reviewing values, see the [Creating a User Extension Field Value](https://developers.cmicglobal.com/v1/docs/creatingupdating-a-user-extension-field-value) guide. | CMiC UI Fieldname | Name | Description | Type | Data Length | Example | | --- | --- | --- | --- | --- | --- | | UEV Number 1 | UevNum1 | User-defined field. Refer to the User Extension Definition endpoint for detail.

For example, if UevNum1 in the PYEMPLOYEE_TABLE is defined in the User Extension Definition as the attribute "Years of Service," you would store the employee's years of service as a numeric value (e.g., 10) in that field. | number | | 10 | | UEV Number 2 | UevNum2 | User-defined field. Refer to the User Extension Definition endpoint for detail.

For example, if UevNum2 in the PYEMPLOYEE_TABLE is defined in the User Extension Definition as the attribute "Years of Service," you would store the employee's years of service as a numeric value (e.g., 10) in that field. | number | | 10 | | UEV Number 3 | UevNum3 | User-defined field. Refer to the User Extension Definition endpoint for detail.

For example, if UevNum3 in the PYEMPLOYEE_TABLE is defined in the User Extension Definition as the attribute "Years of Service," you would store the employee's years of service as a numeric value (e.g., 10) in that field. | number | | 10 | | … | … | … (Additional UEV Numbers follow the same structure) | number | … | … | | UEV Number 20 | UevNum20 | User-defined field. Refer to the User Extension Definition endpoint for detail.

For example, if UevNum20 in the PYEMPLOYEE_TABLE is defined in the User Extension Definition as the attribute "Years of Service," you would store the employee's years of service as a numeric value (e.g., 10) in that field. | number | | 10 | ### UEV Dates Similar to UEV Codes, UEV Dates represents a user-defined field (UDF) configured to store datetime values. All UevDate fields correspond to custom fields for the table specified in the ‘UevUedTableName’ field. Their definitions can be retrieved using the [User Extension Definition](https://developers.cmicglobal.com/apidocs/retrieve-user-extension-fields-definitions-by-code) endpoint. For more details on creating, updating, or reviewing values, see the [Creating a User Extension Field Value](https://developers.cmicglobal.com/v1/docs/creatingupdating-a-user-extension-field-value) guide. | CMiC UI Fieldname | Name | Description | Type | Data Length | Example | | --- | --- | --- | --- | --- | --- | | UEV Date 1 | UevDate1 | User-defined field. Refer to the User Extension Definition endpoint for detail.

For example, if UevDate1 in the PYEMPLOYEE_TABLE is defined in the User Extension Definition as the attribute "Date of Birth," you would store the employee's date of birth as a Date value (e.g., 1994-07-31) in that field. | Date | | 1994-07-31 | | UEV Date 2 | UevDate2 | User-defined field. Refer to the User Extension Definition endpoint for detail.

For example, if UevDate2 in the PYEMPLOYEE_TABLE is defined in the User Extension Definition as the attribute "Date of Birth," you would store the employee's date of birth as a Date value (e.g., 1994-07-31) in that field. | Date | | 1994-07-31 | | UEV Date 3 | UevDate3 | User-defined field. Refer to the User Extension Definition endpoint for detail.

For example, if UevDate3 in the PYEMPLOYEE_TABLE is defined in the User Extension Definition as the attribute "Date of Birth," you would store the employee's date of birth as a Date value (e.g., 1994-07-31) in that field. | Date | | 1994-07-31 | | … | … | … (Additional UEV Dates follow the same structure) | Date | | | | UEV Date 20 | UevDate20 | User-defined field. Refer to the User Extension Definition endpoint for detail.

For example, if UevDate20 in the PYEMPLOYEE_TABLE is defined in the User Extension Definition as the attribute "Date of Birth," you would store the employee's date of birth as a Date value (e.g., 1994-07-31) in that field. | Date | | 1994-07-31 | ## OpenAPI ````json GET /sys-rest-api/rest/1/sdobjusrextvalue { "openapi": "3.0.0", "info": { "title": "API Catalog", "description": "", "version": "1.0.0" }, "servers": [ { "url": "https://mobtest.cmiccloudr12.com/cmictestrti", "description": "CMIC API Server" } ], "security": [ { "cmicBasicAuth": [] } ], "tags": [ { "name": "Highlights" }, { "name": "Asset Management | Equipment" }, { "name": "Asset Management | Fixed Assets" }, { "name": "Asset Management | Purchase Order" }, { "name": "Asset Management | Inventory" }, { "name": "Asset Management | Requisition" }, { "name": "Asset Management | Purchase Change Order" }, { "name": "Bim Model" }, { "name": "Bim Model Revision" }, { "name": "Bim Tag Model" }, { "name": "Bim Tags" }, { "name": "Bim FileUpload Jersey" }, { "name": "Core System | Business Partners" }, { "name": "Core System | Business Partner Addresses" }, { "name": "Core System | Bank" }, { "name": "Core System | Currency" }, { "name": "Core System | Exchange Rates" }, { "name": "Core System | Global Table Text Codes" }, { "name": "Core System | Global Table Regions" }, { "name": "Core System | Terms" }, { "name": "Core System | System Contact" }, { "name": "Core System | Weight Measures" }, { "name": "Core System | Field User Defined Classifiers" }, { "name": "Core System | User Defined Classifiers by Object" }, { "name": "Core System | User Extension Definitions by Object" }, { "name": "Core System | User Extention Field Data Value" }, { "name": "Core System | User Extension Values by Object" }, { "name": "Core System | User System Role" }, { "name": "Core System | User Project Role" }, { "name": "Core System | Documents by Object" }, { "name": "Core System | Audit Status Log by Object" }, { "name": "Core System | Licensed Users" }, { "name": "Core System | Company Access" }, { "name": "Core System | Copy User Settings" }, { "name": "Core System | User Maintenance" }, { "name": "Core System | User Roles" }, { "name": "Core System | Security Groups" }, { "name": "Core System | Job/Project Security" }, { "name": "Core System | Weight Measure with Conversions Code" }, { "name": "Core System | Weight Measure Conversions Code" }, { "name": "Core System | User-defined-fields" }, { "name": "Core System | User-extension" }, { "name": "ECM and Workflow | Image Manager" }, { "name": "Financials | General Ledger" }, { "name": "Financials | Accounts Payable" }, { "name": "Financials | Accounts Receivable" }, { "name": "Preventative Maintenance | Issue Work Orders" }, { "name": "Preventative Maintenance | Issue Work Items" }, { "name": "Preventative Maintenance | Issue Work Budgets" }, { "name": "Preventative Maintenance | Issue Priorities" }, { "name": "Preventative Maintenance | Issue Status" }, { "name": "Preventative Maintenance | Issue Types" }, { "name": "Preventative Maintenance | Accumulative Equipment" }, { "name": "Preventative Maintenance | Work Orders" }, { "name": "Preventative Maintenance | Work Items" }, { "name": "Preventative Maintenance | Work Budgets" }, { "name": "Preventative Maintenance | Priorities" }, { "name": "Preventative Maintenance | Tasks" }, { "name": "HCM | UKG Pay Deductions" }, { "name": "HCM | UKG Pay Earnings" }, { "name": "HCM | UKG Pay Headers" }, { "name": "HCM | UKG Pay Taxes" }, { "name": "HCM | Payroll Geographical States" }, { "name": "HCM | Payroll Trades" }, { "name": "HCM | Payroll Union" }, { "name": "HCM | Payroll Pay Runs" }, { "name": "HCM | Payroll Pay Groups" }, { "name": "HCM | Payroll Tax" }, { "name": "HCM | Payroll Worker Compensation" }, { "name": "HCM | Payroll Work Locations" }, { "name": "HCM | Payroll Trade Pay Rates" }, { "name": "HCM | Payroll Union Pay Rates" }, { "name": "HCM | Payroll Job Pay Rates" }, { "name": "HCM | Payroll Master Benefits" }, { "name": "HCM | Payroll Master Deductions" }, { "name": "HCM | Payroll Ben/Ded/Leave Base Codes" }, { "name": "HCM | Payroll Ben/Ded Plans" }, { "name": "HCM | Payroll Ben/Ded Plan Options" }, { "name": "HCM | Payroll Company Benefits" }, { "name": "HCM | Payroll Company Deductions" }, { "name": "HCM | Payroll Vertex Geographic Locations" }, { "name": "HCM | Payroll Checks" }, { "name": "HCM | Payroll Timesheets" }, { "name": "HCM | Employee" }, { "name": "HCM | Employee (Minimum payload)" }, { "name": "HCM | Employee History" }, { "name": "HCM | Tax Exemptions" }, { "name": "HCM | Employee Tax Overrides" }, { "name": "HCM | Employee Pay Splits" }, { "name": "HCM | Employee Benefits" }, { "name": "HCM | Employee Clock In and Out" }, { "name": "HCM | Employee Deductions" }, { "name": "HCM | Employee Leaves" }, { "name": "HCM | Employee Leave History" }, { "name": "HCM | Employee Hour Types" }, { "name": "HCM | Employee Pay History" }, { "name": "HCM | Employee Work Statuses" }, { "name": "HCM | Employee Security Group" }, { "name": "HCM | Crewtime Crew" }, { "name": "HCM | Crewtime Employee Timesheet" }, { "name": "HCM | Crewtime Equipment Timesheet" }, { "name": "HCM | Crew Maintenance Activity Assignment" }, { "name": "HCM | Crew Maintenance Member Assignment" }, { "name": "HCM | Crew Maintenance Member Trade and Union Assignment" }, { "name": "HCM | Crew Maintenance Equipment Assignment" }, { "name": "HCM | Crew Maintenance Equipment Detail Assignment" }, { "name": "HCM | HR Requisitions" }, { "name": "HCM | HR Relations" }, { "name": "HCM | HR Employee Skills" }, { "name": "HCM | HR Incident" }, { "name": "HCM | HR Employee Relatives / Dependents" }, { "name": "HCM | HR Employee Positions" }, { "name": "HCM | HR Applicants" }, { "name": "HCM | HR Applications" }, { "name": "HCM | Vertex Location City" }, { "name": "HCM | HR Application History" }, { "name": "HCM | HR Dependent Benefits" }, { "name": "HCM | HR Dependent Deductions" }, { "name": "HCM | HR Employee Elected Plans" }, { "name": "HCM | HR Employee Training Certifications" }, { "name": "HCM | HR Trainings" }, { "name": "HCM | E-Timesheets" }, { "name": "HCM | System Contacts" }, { "name": "HCM | System User Payroll Security Group" }, { "name": "HCM | Payroll Timesheet Posting" }, { "name": "HCM | CrewTimesheet Posting" }, { "name": "HCM | HR Positions Master" }, { "name": "HCM | Payroll Pay Periods" }, { "name": "HCM | Payroll Rate Codes" }, { "name": "HCM | Payroll Overhead Codes and Rates" }, { "name": "HCM | Payroll Assigned Overhead to Jobs" }, { "name": "Materials Management | Material Sale Orders" }, { "name": "Materials Management | Material Sale Orders Details" }, { "name": "Materials Management | Truck Rate Detail" }, { "name": "Opportunity Management | Competitors" }, { "name": "Opportunity Management | Opportunities" }, { "name": "Opportunity Management | Revenue Details" }, { "name": "Opportunity Management | Opportunity History" }, { "name": "Opportunity Management | Organization" }, { "name": "Project Controls | Job Billing" }, { "name": "Project Controls | Job Cost" }, { "name": "Project Controls | PCI Details" }, { "name": "Project Controls | Unposted PCI Details" }, { "name": "Project Controls | PCI Headers" }, { "name": "Project Controls | Owner Change Orders" }, { "name": "Project Controls | CM Statuses" }, { "name": "Project Controls | CM Types" }, { "name": "Project Controls | CM Vendor Details" }, { "name": "Project Controls | Post PCI" }, { "name": "Project Management | Uploading Documents" }, { "name": "Project Management | Downloading Documents" }, { "name": "Project Management | Foreign Bid Item Imports" }, { "name": "Project Management | Communications" }, { "name": "Project Management | Daily Journals" }, { "name": "Project Management | Communications Types" }, { "name": "Project Management | Daily Journal Daily Work Plans" }, { "name": "Project Management | Daily Journal Field Forces" }, { "name": "Project Management | Daily Journal Labour" }, { "name": "Project Management | Daily Journal Materials" }, { "name": "Project Management | Daily Journal Owner Equipment" }, { "name": "Project Management | Daily Journal Quality Control" }, { "name": "Project Management | Daily Journal Tasks" }, { "name": "Project Management | Daily Journal Trade Equipment" }, { "name": "Project Management | Daily Journal Transactions" }, { "name": "Project Management | Daily Journal User Defined Data" }, { "name": "Project Management | Daily Journal Visitors" }, { "name": "Project Management | Daily Journal Bill Details" }, { "name": "Project Management | Field Work Directives" }, { "name": "Project Management | Contract Types" }, { "name": "Project Management | Company Contacts" }, { "name": "Project Management | Distribution BCC" }, { "name": "Project Management | Distribution CC" }, { "name": "Project Management | Field Work Directive Statuses" }, { "name": "Project Management | Issues" }, { "name": "Project Management | Key Players" }, { "name": "Project Management | Meetings" }, { "name": "Project Management | Meeting Attendees" }, { "name": "Project Management | Meeting Item Statuses" }, { "name": "Project Management | Meeting Tracks" }, { "name": "Project Management | Notes" }, { "name": "Project Management | Projects" }, { "name": "Project Management | Project Items" }, { "name": "Project Management | Project Item Phase Segment Sums" }, { "name": "Project Management | Project Partners" }, { "name": "Project Management | Notices" }, { "name": "Project Management | Notice Statuses" }, { "name": "Project Management | Owner JS Query" }, { "name": "Project Management | PCI Real Locations" }, { "name": "Project Management | Project Contacts" }, { "name": "Project Management | RFIs (Requests for Information)" }, { "name": "Project Management | RFI Statuses" }, { "name": "Project Management | Submittal Packages" }, { "name": "Project Management | Submittal Package Details" }, { "name": "Project Management | Submittal Package Status" }, { "name": "Project Management | Submittals" }, { "name": "Project Management | Submittal Status" }, { "name": "Project Management | Transmittals" }, { "name": "Project Management | Subcontract Headers" }, { "name": "Project Management | Subcontract Schedules" }, { "name": "Project Management | Subcontract Sechedule Phase Segment Sums" }, { "name": "Project Management | User Roles" }, { "name": "Project Management | Punchlists" }, { "name": "Project Management | Punchlist Details" }, { "name": "Project Management | Punchlist Statuses" }, { "name": "Project Management | Meeting Items" }, { "name": "Project Management | Self Perform Vendor" }, { "name": "Project Management | Submittal Types" }, { "name": "Project Management | Assign contact and partner to project" }, { "name": "Project Management | Subcontract Prequal" }, { "name": "Project Management | Bid Item Package" } ], "paths": { "/sys-rest-api/rest/1/sdobjusrextvalue": { "get": { "tags": [ "Core System | User Extension Values by Object" ], "summary": "Retrieve User Extension Field Value By Object", "description": "## Overview\n\nUser Extensions allow the functionality of the software to be extended through the creation of custom input fields. These input fields are attached to custom tables. The tables allow for storage and easy access of all miscellaneous information.\n\n## Notes\n\n- Before working with a User Extension Field value, retrieve its definition using the User Extension Definition endpoint. Once the definition is established in CMiC, you can create, retrieve, or update the field’s value as needed\n \n- Finders must be used to properly query GET requests.\n \n\n## UI Navigation\n\nSystem > User Extension > Field Maintenance\n\n## Reference Article\n\n- [Creating a User Extension Field Value](https://developers.cmicglobal.com/v1/docs/creatingupdating-a-user-extension-field-value)\n \n- [UE Maintenance Overview](https://docs.cmicglobal.com/portal/Content/E_Reference_Material/SD_-_System_Data/Reference/User_Extensions/UE_Maintenance.htm)\n \n\n## Path Parameters\n\n| Parameter | Description | Example |\n| --- | --- | --- |\n| VUUID | The VUuid attribute is the Unique row ID | /sys-rest-api/rest/1/sdobjusrextvalue/E41D15789AA9807FE0530100007F304F |\n\n## Query Standards\n\n| Key | Recommended | Description |\n| --- | --- | --- |\n| finder | Yes | Filters data based on attributes. See finder details below. Finders can be combined using a comma delimiter between parameters that implies an \"and\" statement. For more information on using the finder functionality please see \\[Best Practice |\n| limit | Yes | A limit restricts the number of resources returned inside the resource collection. If the limit exceeds the resource count, then the framework will return all available resources. For additional information on using the limit functionality please visit \\[Best Practice |\n| offset | Yes | The offset skips a specified number of items in a data list before it starts showing results. For example, if you set an offset of 10, it skips the first 10 items and begins showing from the 11th item. For additional information on using Offset functionality please visit \\[Best Practice |\n| orderBy | Yes | The orderBy attribute retrieves rows using an order ensuring the response payload displays data in the order supplied in the URL parameter using the GET method. For more information on using orderBy functionality please visit \\[Best Practice |\n\n## (User Extension Field Value) Finders\n\n| Finder | Parameter | Data Type | Description | Example |\n| --- | --- | --- | --- | --- |\n| PrimaryKey | UevVUuid | string | Filter values by VUUID | /sys-rest-api/rest/1/sdobjusrextvalue?finder=PrimaryKey;UevVUuid=E41D15789AA9807FE0530100007F304F |\n| SdObjUsrExtValueFinder | AuditDate | date | Filter records by audit date (UevIuCreateDate). This finder will retrieve records that have a created date on or after the specified date. When using this finder, this parameter must be used in tandem with the Schema Name, Table Name, and the all associated Object keys. | /sys-rest-api/rest/1/sdobjusrextvalue?finder=SdObjUsrExtValueFinder;AuditDate=2010-10-31, SchemaName=DA, TableName=PYEMPLOYEE_TABLE,ObjectKey1=ZZ-100 |\n| SdObjUsrExtValueFinder | ObjectKey1 | string | Filter record by Object Key 1. When using this finder, this parameter must be used in tandem with the Schema Name, Table Name, and the all other associated Object keys. | /sys-rest-api/rest/1/sdobjusrextvalue?finder=SdObjUsrExtValueFinder; SchemaName=DA, TableName=BPVENDORS,ObjectKey1=ZZ, ObjectKey2=00112233 |\n| SdObjUsrExtValueFinder | ObjectKey2 | string | Filter record by Object Key 2. When using this finder, this parameter must be used in tandem with the Schema Name, Table Name, and the all other associated Object keys. | /sys-rest-api/rest/1/sdobjusrextvalue?finder=SdObjUsrExtValueFinder; SchemaName=DA, TableName=BPVENDORS,ObjectKey1=ZZ, ObjectKey2=00112233 |\n| SdObjUsrExtValueFinder | ObjectKey3 | string | Filter record by Object Key 3. When using this finder, this parameter must be used in tandem with the Schema Name, Table Name, and the all other associated Object keys. | /sys-rest-api/rest/1/sdobjusrextvalue?finder=SdObjUsrExtValueFinder; SchemaName=DA, TableName=SCMAST,ObjectKey1=CCC, ObjectKey2=1TIME, ObjectKey3=CCCJB-0000001, ObjectKey4=000 |\n| SdObjUsrExtValueFinder | ObjectKey4 | string | Filter record by Object Key 4. When using this finder, this parameter must be used in tandem with the Schema Name, Table Name, and the all other associated Object keys. | /sys-rest-api/rest/1/sdobjusrextvalue?finder=SdObjUsrExtValueFinder; SchemaName=DA, TableName=SCMAST,ObjectKey1=CCC, ObjectKey2=1TIME, ObjectKey3=CCCJB-0000001, ObjectKey4=000 |\n| SdObjUsrExtValueFinder | SchemaName | string | Filter record by Schema Name. When using this finder, this parameter must be used in tandem with the Table Name, and all associated Object keys | /sys-rest-api/rest/1/sdobjusrextvalue?finder=SdObjUsrExtValueFinder; SchemaName=DA, TableName=BPVENDORS,ObjectKey1=ZZ, ObjectKey2=00112233 |\n| SdObjUsrExtValueFinder | TableName | string | Filter record by Table Name. When using this finder, this parameter must be used in tandem with the Schema Name, and all associated Object keys | /sys-rest-api/rest/1/sdobjusrextvalue?finder=SdObjUsrExtValueFinder; SchemaName=DA, TableName=BPVENDORS,ObjectKey1=ZZ, ObjectKey2=00112233 |\n| UevCodeFinder | AuditDate | string | Filter records by audit date (UevIuCreateDate). This finder will retrieve records that have a created date on or after the specified date. | /sys-rest-api/rest/1/sdobjusrextvalue?finder=UevCodeFinder;AuditDate=2025-01-31 |\n| UevCodeFinder | SchemaName | string | Filter records by Schema Name. | /sys-rest-api/rest/1/sdobjusrextvalue?finder=UevCodeFinder;SchemaName=DA |\n| UevCodeFinder | TableName | string | Filter Records by Table Name | /sys-rest-api/rest/1/sdobjusrextvalue?finder=UevCodeFinder;TableName=PYEMPLOYEE_TABLE |\n| UevCodeFinder | UevCode1Var | string | Filter Records by UevCode1. | /sys-rest-api/rest/1/sdobjusrextvalue?finder=UevCodeFinder;UevCode1Var=1 |\n| UevCodeFinder | UevCode2Var | string | Filter Records by UevCode2. | /sys-rest-api/rest/1/sdobjusrextvalue?finder=UevCodeFinder;UevCode2Var=20122022 |\n| UevCodeFinder | UevCode3Var | string | Filter Records by UevCode3. | /sys-rest-api/rest/1/sdobjusrextvalue?finder=UevCodeFinder;UevCode3Var=100 |\n| UevCodeFinder | UevCode\\[1-20\\]Var | string | Filter records by UEV Code fields (replace \\[1-20\\] with the desired number). | /sys-rest-api/rest/1/sdobjusrextvalue?finder=UevCodeFinder;UevCode18Var=100100 |\n| findByDate | AuditDate | string | Filter records by audit date (UevIuCreateDate). This finder will retrieve records that have a created date on or after the specified date. | /sys-rest-api/rest/1/sdobjusrextvalue?finder=findByDate;AuditDate=2025-01-31 |\n| findByDate | SchemaName | string | Filter records by Schema Name. | /sys-rest-api/rest/1/sdobjusrextvalue?finder=findByDate;SchemaName=DA |\n| findByDate | TableName | string | Filter Records by Table Name | /sys-rest-api/rest/1/sdobjusrextvalue?finder=findByDate;TableName=PYEMPLOYEE_TABLE |\n| findByDate | UevCode10Var | string | Filter Records by UevCode1. | /sys-rest-api/rest/1/sdobjusrextvalue?finder=findByDate;UevCode1Var=1 |\n| findByDate | UevCode2Var | string | Filter Records by UevCode2. | /sys-rest-api/rest/1/sdobjusrextvalue?finder=findByDate;UevCode2Var=20122022 |\n| findByDate | UevCode3Var | string | Filter Records by UevCode3. | /sys-rest-api/rest/1/sdobjusrextvalue?finder=findByDate;UevCode3Var=100 |\n| findByDate | UevCode\\[1-20\\]Var | string | Filter records by UEV Code fields (replace \\[1-20\\] with the desired number). | /sys-rest-api/rest/1/sdobjusrextvalue?finder=findByDate;UevCode18Var=1234 |\n\n## (User Extension Field Value) Attributes\n\n### General Attributes\n\n| CMiC UI Fieldname | Name | Description | Type | Data Length | Example | Required |\n| --- | --- | --- | --- | --- | --- | --- |\n| Schema Name | UevUedSchemaName | Static code 'DA' | string | 30 | ‘DA’ | Yes |\n| Table Name | UevUedTableName | Enter the Object Type Table Name. In CMiC, object tables are database tables that store rows of records.

Click [here](https://developers.cmicglobal.com/v1/docs/object-key-tables) to view a list of Object Tables. | string | 30 | ‘PYEMPLOYEE_TABLE’ | Yes |\n| VUUID | UevVUuid | The VUuid attribute is the Unique row ID | string | 64 | E41D157899B9807FE0530100007F304F | No |\n| Create Date | UevIuCreateDate | This field displays the date and time when any user-defined field (UDF) value was first assigned to a record. For example, if you initially set UEV_CODE1 for a record, that timestamp becomes the create date—even if additional UDF values (such as UEV_CODE2, UEV_NUM1, etc.) are added later. | Datetime | | 2018-09-25T11:58:09-04:00 | |\n| Update Date | UevIuUpdateDate | This field shows the most recent date and time when any UDF value within the record was created or updated. Since all UDF values for a record are stored together, UevIuUpdateDate reflects the timestamp of the latest modification made to any of those fields. | Datetime | | 2025-01-27T17:52:51-05:00 | |\n| (Deprecated) | UevObjectColumn | This field has been deprecated and should be left blank. | string | 64 | \\- | |\n| (Deprecated) | UevObjectValue | This field has been deprecated and should be left blank. | string | 4000 | \\- | |\n| Object Keys | UevObjectKey | Please refer to the Object Keys Section below for more information | … | … | … | |\n| UEV Codes | UevCode | Please refer to the UEV Code Section below for more information | … | … | … | |\n| UEV Numbers | UevNum | Please refer to the UEV Number Section below for more information | … | … | … | |\n| UEV Dates | UevDate | Please refer to the UEV Date Section below for more information | … | … | … | |\n\n### Object Keys\n\nThe UEV Keys in the Object Table are unique identifiers used to retrieve specific records. Refer to the [Object Key Tables](https://developers.cmicglobal.com/v1/docs/object-key-tables) for a comprehensive list of Object Types and their corresponding Keys.\n\nCMiC UI Fieldname\n\nName\n\nDescription\n\nType\n\nData Length\n\nExample\n\nObject Key 1\n\nUevObjectKey1\n\nUnique identifier for record retrieval.\n\nFor example, when using PYEMPLOYEE_TABLE, Object Key 1 corresponds to Emp Number. In which case you would enter the Employee number (e.g. 1406)\n\nstring\n\n30\n\n1406\n\nObject Key 2\n\nUevObjectKey2\n\nUnique identifier for record retrieval. For example, when using BPVENDORS, Object Key 2 corresponds to Bp Code. In which case you would enter the BP Code (e.g. ZZ)\n\nstring\n\n30\n\nZZ\n\nObject Key 3\n\nUevObjectKey3\n\nUnique identifier for record retrieval. For example, when using CMMAST, Object Key 3 corresponds to Cmm Code. In which case you would enter the Cmm Code (e.g. 0009EXT)\n\nstring\n\n30\n\n0009EXT\n\nObject Key 4\n\nUevObjectKey4\n\nUnique identifier for record retrieval. For example, when using SCMAST, Object Key 4 corresponds to Change Code. In which case you would enter the Chagne Code (e.g. 001)\n\nstring\n\n30\n\n001\n\n### UEV Codes\n\nUEV Code represents a user-defined field (UDF) configured to store string values. All UevCode fields correspond to custom fields for the table specified in the ‘UevUedTableName’ field. Their definitions can be retrieved using the [User Extension Definition](https://developers.cmicglobal.com/apidocs/retrieve-user-extension-fields-definitions-by-code) endpoint. For more details on creating, updating, or reviewing values, see the [Creating a User Extension Field Value](https://developers.cmicglobal.com/v1/docs/creatingupdating-a-user-extension-field-value) guide.\n\n| CMiC UI Fieldname | Name | Description | Type | Data Length | Example |\n| --- | --- | --- | --- | --- | --- |\n| Uev Code 1 | UevCode1 | User-defined field. Refer to the User Extension Definition endpoint for detail.

For example, UevCode1 associated with the PYEMPLOYEE_TABLE might be defined in the User Extension Definition as the attribute \"Driver License.\" In this case, you would store the driver's license information in that field (e.g. AW-1425-77888). Alternatively, UevCode1 could represent a different user-defined value depending on its configuration.. | string | 4000 | AW-1425-77888 |\n| Uev Code 2 | UevCode2 | User-defined field. Refer to the User Extension Definition endpoint for details

For example, UevCode2 associated with the PYEMPLOYEE_TABLE might be defined in the User Extension Definition as the attribute \"Driver License.\" In this case, you would store the driver's license information in that field(e.g. AW-1425-77888). Alternatively, UevCode2 could represent a different user-defined value depending on its configuration. | string | 4000 | AW-1425-77888 |\n| Uev Code 3 | UevCode3 | User-defined field. Refer to the User Extension Definition endpoint for details

For example, UevCode3 associated with the PYEMPLOYEE_TABLE might be defined in the User Extension Definition as the attribute \"Driver License.\" In this case, you would store the driver's license information in that field (e.g. AW-1425-77888). Alternatively, UevCode3 could represent a different user-defined value depending on its configuration. | string | 4000 | AW-1425-77888 |\n| … | … | ... (Additional UEV Codes follow the same structure) | string | 4000 | … |\n| UEV Code 100 | UevCode100 | User-defined field. Refer to the User Extension Definition endpoint for details.

For example, UevCode100 associated with the PYEMPLOYEE_TABLE might be defined in the User Extension Definition as the attribute \"Driver License.\" In this case, you would store the driver's license information in that field (e.g. AW-1425-77888). Alternatively, UevCode100 could represent a different user-defined value depending on its configuration. | string | 4000 | AW-1425-77888 |\n\n### UEV Numbers\n\nSimilar to UEV Codes, UEV Numbers represents a user-defined field (UDF) configured to store numeric values. All UevNum fields correspond to custom fields for the table specified in the ‘UevUedTableName’ field. Their definitions can be retrieved using the [User Extension Definition](https://developers.cmicglobal.com/apidocs/retrieve-user-extension-fields-definitions-by-code) endpoint. For more details on creating, updating, or reviewing values, see the [Creating a User Extension Field Value](https://developers.cmicglobal.com/v1/docs/creatingupdating-a-user-extension-field-value) guide.\n\n| CMiC UI Fieldname | Name | Description | Type | Data Length | Example |\n| --- | --- | --- | --- | --- | --- |\n| UEV Number 1 | UevNum1 | User-defined field. Refer to the User Extension Definition endpoint for detail.

For example, if UevNum1 in the PYEMPLOYEE_TABLE is defined in the User Extension Definition as the attribute \"Years of Service,\" you would store the employee's years of service as a numeric value (e.g., 10) in that field. | number | | 10 |\n| UEV Number 2 | UevNum2 | User-defined field. Refer to the User Extension Definition endpoint for detail.

For example, if UevNum2 in the PYEMPLOYEE_TABLE is defined in the User Extension Definition as the attribute \"Years of Service,\" you would store the employee's years of service as a numeric value (e.g., 10) in that field. | number | | 10 |\n| UEV Number 3 | UevNum3 | User-defined field. Refer to the User Extension Definition endpoint for detail.

For example, if UevNum3 in the PYEMPLOYEE_TABLE is defined in the User Extension Definition as the attribute \"Years of Service,\" you would store the employee's years of service as a numeric value (e.g., 10) in that field. | number | | 10 |\n| … | … | … (Additional UEV Numbers follow the same structure) | number | … | … |\n| UEV Number 20 | UevNum20 | User-defined field. Refer to the User Extension Definition endpoint for detail.

For example, if UevNum20 in the PYEMPLOYEE_TABLE is defined in the User Extension Definition as the attribute \"Years of Service,\" you would store the employee's years of service as a numeric value (e.g., 10) in that field. | number | | 10 |\n\n### UEV Dates\n\nSimilar to UEV Codes, UEV Dates represents a user-defined field (UDF) configured to store datetime values. All UevDate fields correspond to custom fields for the table specified in the ‘UevUedTableName’ field. Their definitions can be retrieved using the [User Extension Definition](https://developers.cmicglobal.com/apidocs/retrieve-user-extension-fields-definitions-by-code) endpoint. For more details on creating, updating, or reviewing values, see the [Creating a User Extension Field Value](https://developers.cmicglobal.com/v1/docs/creatingupdating-a-user-extension-field-value) guide.\n\n| CMiC UI Fieldname | Name | Description | Type | Data Length | Example |\n| --- | --- | --- | --- | --- | --- |\n| UEV Date 1 | UevDate1 | User-defined field. Refer to the User Extension Definition endpoint for detail.

For example, if UevDate1 in the PYEMPLOYEE_TABLE is defined in the User Extension Definition as the attribute \"Date of Birth,\" you would store the employee's date of birth as a Date value (e.g., 1994-07-31) in that field. | Date | | 1994-07-31 |\n| UEV Date 2 | UevDate2 | User-defined field. Refer to the User Extension Definition endpoint for detail.

For example, if UevDate2 in the PYEMPLOYEE_TABLE is defined in the User Extension Definition as the attribute \"Date of Birth,\" you would store the employee's date of birth as a Date value (e.g., 1994-07-31) in that field. | Date | | 1994-07-31 |\n| UEV Date 3 | UevDate3 | User-defined field. Refer to the User Extension Definition endpoint for detail.

For example, if UevDate3 in the PYEMPLOYEE_TABLE is defined in the User Extension Definition as the attribute \"Date of Birth,\" you would store the employee's date of birth as a Date value (e.g., 1994-07-31) in that field. | Date | | 1994-07-31 |\n| … | … | … (Additional UEV Dates follow the same structure) | Date | | |\n| UEV Date 20 | UevDate20 | User-defined field. Refer to the User Extension Definition endpoint for detail.

For example, if UevDate20 in the PYEMPLOYEE_TABLE is defined in the User Extension Definition as the attribute \"Date of Birth,\" you would store the employee's date of birth as a Date value (e.g., 1994-07-31) in that field. | Date | | 1994-07-31 |", "parameters": [ { "name": "finder", "in": "query", "schema": { "type": "string" }, "example": "SdObjUsrExtValueFinder; TableName=PMPROJECT_TABLE, AuditDate=2015-01-01, SchemaName=DA, ObjectKey1=001, ObjectKey2=14001" }, { "name": "limit", "in": "query", "schema": { "type": "integer" }, "example": "500" }, { "name": "offset", "in": "query", "schema": { "type": "integer" }, "example": "0" }, { "name": "totalResults", "in": "query", "schema": { "type": "boolean" }, "example": "true" }, { "name": "orderBy", "in": "query", "schema": { "type": "string" }, "example": "evUedSchemaName:desc" } ], "responses": { "200": { "description": "Successful response", "content": { "application/json": {} } } } } } }, "components": { "securitySchemes": { "cmicBasicAuth": { "type": "http", "scheme": "basic", "description": "Basic authentication" } } } } ````